%%
%% This is file `IMTEKbrief.cls',
%% Copyright (C) 2007 by Simon Dreher & Daniel Mader
%% 
%% This file may be distributed and/or modified under the
%% conditions of the LaTeX Project Public License, either
%% version 1.2 of this license or (at your option) any later
%% version. The latest version of this license is in:
%% 
%% http://www.latex-project.org/lppl.txt
%% 
%% and version 1.2 or later is part of all distributions of
%% LaTeX version 1999/12/01 or later.
%% 
\NeedsTeXFormat{LaTeX2e}[1999/12/01]
\ProvidesClass{IMTEKbrief}
   [2007/08/27 v0.99 IMTEK-Briefvorlage -- supported by D.Mader mader@imtek.de & S.Dreher dreher@imtek.de]
%
\newif\if@moretext\@moretextfalse
\DeclareOption{moretext}{\@moretexttrue}
\newif\if@nonsymm\@nonsymmfalse
\DeclareOption{nonsymm}{\@nonsymmtrue}
\newif\if@DIN\@DINtrue
\DeclareOption{DINfalse}{\@DINfalse}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{scrlttr2}}
\ProcessOptions\relax
\LoadClass{scrlttr2}
%
\@ifclassloaded{scrlttr2}{%
  \@ifclasslater{scrlttr2}{2007/03/08}{%
    \GenericWarning{%
      (IMTEKbrief.cls)\@spaces\@spaces\@spaces\@spaces\@spaces\@spaces%
    }{%
      IMTEKbrief Warning:\space
      This class was made and successfully tested\MessageBreak
      only with KOMA-Script letter class `scrlttr2'\MessageBreak
      with version date *2007-03-07*.\MessageBreak
      Use with much older or newer versions of `scrlttr2'\MessageBreak
      may result in a lot of errors or unexpected behaviour\@gobble
    }%
  }{}%
}{}
%
\RequirePackage{graphicx}
\KOMAoptions{%% sofern auskommentiert: Default-Werte!
% 	fromalign=right,%
% 	fromrule=afteraddress,%
% 	fromphone=true,%
% 	fromemail=true,%
% 	fromurl=true,%
% 	foldmarks=false,%
% 	backaddress=true,%
% 	addrfield=true,%
%       pagenumber=footcenter,%
% 	footsepline=false,%
% 	headsepline=false,%
	enlargefirstpage=true
	}
% --------------------------------------------------------------------------------------------


%% page layout ===============================================================================
\if@nonsymm
    \relax
\else
%% strikt DIN 5008:
\RequirePackage[left=24.1mm,%
                right=24.1mm,%
                bottom=4.5cm%
                ]{geometry}
\fi
\if@moretext
    \LoadLetterOption{DINmtext}
\else
    \LoadLetterOption{DIN}
\fi
%
%% Textkoerper unsymmetrisch links bei scrlttr2-Default (DIN 5008 + DIN 676!) Verletzt aber die Regeln:
\if@nonsymm
    \LoadLetterOption{nonsymm}
\else
%
%% Adressfenster kleiner und linksbuendig mit Textkoerper:
    \if@DIN
        \LoadLetterOption{textwidth}
    \fi
\fi
% --------------------------------------------------------------------------------------------


%% set and define global IMTEK KOMA-variables ================================================
%%
%% default KOMA-variables:
% \setkomavar{phoneseparator}{ }
% \setkomavar{faxseparator}{ }
% \setkomavar{emailseparator}{ }

%% Ruecksendeadresse mit normaler \underline:
% \setkomavar{backaddress}{IMTEK\\\usekomavar{fromchair}\\\usekomavar{fromcity}}
%% Ruecksendeadresse mit durchgezogener \underline:
\setkomavar{backaddress}{%
    \makebox[0pt][l]{%
        \underline{%
            \makebox[\useplength{firstheadwidth}][l]{%
                IMTEK\\\usekomavar{fromchair}\\\usekomavar{fromcity}%
            }%
        }%
    }%
}

\setkomavar{backaddressseparator}{ $\cdot$ }
\setkomavar{place}{Freiburg\,i.\,Br.}
\setkomavar{date}{\today}
%%
%% new custom variables for the IMTEK:
\newkomavar{fromdepartment}
\newcommand{\fromdepartment}{Department of Microsystems Engineering}
\AfterPackage*{babel}{
  \addto{\extrasngerman}{\def\fromdepartment{Institut f\"ur Mikrosystemtechnik}}
  \addto{\extrasenglish}{\def\fromdepartment{Department of Microsystems \mbox{Engineering}}}
}%
\setkomavar{fromdepartment}{\fromdepartment}

\newkomavar{fromuniversity}
\newcommand{\fromuniversity}{University of Freiburg -- IMTEK}
\AfterPackage*{babel}{
  \addto{\extrasngerman}{\def\fromuniversity{Albert-Ludwigs-Universit\"at -- IMTEK}}
  \addto{\extrasenglish}{\def\fromuniversity{University of Freiburg -- IMTEK}}
}%
\setkomavar{fromuniversity}{\fromuniversity}

\newkomavar{fromfunction}                       %% see user-defined .lco

\newkomavar{fromchair}
\setkomavar{fromchair}{\fromchair}              %% see user-defined .lco
\newcommand{\fromcity}{79110 Freiburg, Germany}
\newkomavar{fromcity}
\setkomavar{fromcity}{\fromcity}                %% see user-defined .lco
\newkomavar{fromphonesuffix}                    %% see user-defined .lco
\newkomavar{fromfaxsuffix}                      %% see user-defined .lco

\newcommand{\fromphone}{+49\,761~203-}
\AfterPackage*{babel}{
  \addto{\extrasngerman}{\def\fromphone{0761~203-}}
  \addto{\extrasenglish}{\def\fromphone{+49\,761~203-}}
}%
\setkomavar{fromphone}{\fromphone}

\newcommand{\fromfax}{+49\,761~203-}
\AfterPackage*{babel}{
  \addto{\extrasngerman}{\def\fromfax{0761~203-}}
  \addto{\extrasenglish}{\def\fromfax{+49\,761~203-}}
}%
%
\setkomavar{fromfax}{\fromfax}
\newkomavar{leftlogo}
\newkomavar{rightlogo}
\newkomavar{imtekicon}
\RequirePackage{graphicx}
\setkomavar{leftlogo}{\includegraphics[width=\useplength{leftlogowidth}]{IMTEK_Logo_SW}}
\setkomavar{rightlogo}{\includegraphics[width=\useplength{infocolwidth}]{Uni_Logo}}
\setkomavar{imtekicon}{\includegraphics[width=4mm]{IMTEKiconSW}}
% --------------------------------------------------------------------------------------------


%% defintion of font styles for letter elements ==============================================
% \addtokomafont{backaddress}{\rmfamily}
% \addtokomafont{descriptionlabel}{}
% \addtokomafont{fromaddress}{\sffamily}
% \addtokomafont{fromname}{\sffamily}
% \addtokomafont{pagefoot}{\sffamily}
\addtokomafont{pagehead}{\sffamily}
\addtokomafont{pagenumber}{\sffamily\footnotesize}
% \addtokomafont{subject}{\sffamily}
% \addtokomafont{title}{\sffamily}
% --------------------------------------------------------------------------------------------


%% definition of custom pseudolength settings ================================================
\@setplength{sigindent}{0pt}
\if@moretext
    \@setplength{refvpos}{92mm}%% reference line below date
\else
    \@setplength{refvpos}{110mm}%% reference line below date
\fi
% --------------------------------------------------------------------------------------------


%% definition of the custom IMTEK letter head ================================================
\@setplength{firstheadvpos}{0pt}%% start measuring from top of the page for firsthead
\@newplength{leftlogowidth}%
\@setplength{leftlogowidth}{3cm}%
\@newplength{infocolwidth}%
\@setplength{infocolwidth}{6cm}%
\@newplength{intinfocolwidth}%% in order to have alignment with logo text inside the info block
\@setplength{intinfocolwidth}{\useplength{infocolwidth}}%
\@addtoplength{intinfocolwidth}{-4pt}%
%
\RequirePackage{array}%% needed for more alignment options within tabular environment
%
\firsthead{%
    \fontsize{8}{12}\sffamily
%% use picture environment to avoid over-/underfull boxes warnings:
    \begin{picture}(0,0)%
	\put(0,0){\parbox[t]{\useplength{leftlogowidth}}{%
	    \if@moretext
		\vspace{1.5cm}%
	    \else
		\vspace{3.25cm}%
	    \fi
	    \usekomavar{leftlogo}
	    }%end of parbox
        }%end of put
    \end{picture}
    \hfill
%% use picture environment to avoid over-/underfull boxes warnings:
    \begin{picture}(0,0)%
        \put(0,0){
            \begin{minipage}[t]{\useplength{infocolwidth}}
		\if@moretext
		    \vspace{1.35cm}%
		\else
		    \vspace{3.165cm}%
		\fi
                \usekomavar{rightlogo}\\[0.3ex]
%% Realisierung des Infoblocks mit zwei Moeglichkeiten:
%% 1) in tabular-Umgebung (4pt Spaltenabstand links zur Ausrichtung am Logo-Text!)
%                 \begin{tabular}{@{\hspace{4pt}} >{\raggedright}p{\useplength{intinfocolwidth}} @{}}%
%                     {\strut\bfseries  \usekomavar{fromdepartment}}\\
%                     {\bfseries        \usekomavar{fromchair}}
%                 \end{tabular}\vspace{1.5ex}
%% 2) (=besser!) in parbox (4pt horiz. Abstand davor zur Ausrichtung am Logo-Text!)
                \hspace*{4pt}\parbox{\useplength{intinfocolwidth}}{%
                    {\strut \bfseries   \usekomavar{fromuniversity}}\\%
                    {\bfseries          \usekomavar{fromdepartment}}\\%
                    {\bfseries          \usekomavar{fromchair}}\\%
                \mbox{}}\\%end of parbox
%% naechster Block:
                \hspace*{4pt}%
                \parbox{\useplength{intinfocolwidth}}{%
                    {\usekomafont{fromname}             \usekomavar{fromname}\\}
                    \ifkomavarempty{fromfunction}{}{    \usekomafont{fromname}\usekomavar{fromfunction}\\}
                    {\usekomafont{fromaddress}          \usekomavar{fromaddress}\\}
                    {\usekomafont{fromaddress}          \usekomavar{fromcity}\\}
                \mbox{}}\\%end of parbox
%% Kontaktdaten einspaltig:
% 		\hspace*{4pt}%
%                 \parbox{\useplength{intinfocolwidth}}{%
%                     \ifkomavarempty{fromphonesuffix}{}{%
%                         \usekomafont{fromaddress}\usekomavar*{fromphone}    \usekomavar{fromphone}\usekomavar{fromphonesuffix}\\}
%                     \ifkomavarempty{fromfaxsuffix}{}{%
%                         \usekomafont{fromaddress}\usekomavar*{fromfax}      \usekomavar{fromfax}\usekomavar{fromfaxsuffix}\\}
%                     \ifkomavarempty{fromemail}{}{%
%                         \usekomafont{fromaddress}\usekomavar*{fromemail}    \usekomavar{fromemail}\\}
%                     \ifkomavarempty{fromurl}{}{%
%                         \usekomafont{fromaddress}\usekomavar*{fromurl}      \usekomavar{fromurl}\\}
% 		\mbox{}}\\%end of parbox
%% Kontaktdaten zweispaltig:
                \hspace*{4pt}%
                \parbox{\useplength{intinfocolwidth}}{%
                    \mbox{}%\llap braucht mind. ein Zeichen vorher!
                    \ifkomavarempty{fromphonesuffix}{}{%
                        \usekomafont{fromaddress}\llap{\usekomavar*{fromphone}~}\usekomavar{fromphone}\usekomavar{fromphonesuffix}\\}%
                    \ifkomavarempty{fromfaxsuffix}{}{%
                        \usekomafont{fromaddress}\llap{\usekomavar*{fromfax}~}\usekomavar{fromfax}\usekomavar{fromfaxsuffix}\\}%
                    \ifkomavarempty{fromemail}{}{%
                        \usekomafont{fromaddress}\llap{\usekomavar*{fromemail}~}\usekomavar{fromemail}\\}%
                    \ifkomavarempty{fromurl}{}{%
                        \usekomafont{fromaddress}\llap{\usekomavar*{fromurl}~}\usekomavar{fromurl}\\}%
                \mbox{}}\\%end of parbox
%% Realisierung mit tabular funktioniert leider nicht, da *&* auch dann gelesen wird, wenn \ifkomavarempty{xyzvar}==true...
%                 \begin{tabular}{@{\hspace{4pt}} l @{}p{\useplength{intinfocolwidth}}@{}}%
%                     \ifkomavarempty{fromphonesuffix}{}{\llap{\usekomafont{fromaddress}\usekomavar*{fromphone}} &%
%                         \usekomafont{fromaddress}\usekomavar{fromphone}\usekomavar{fromphonesuffix}\tabularnewline}
%                     \ifkomavarempty{fromfaxsuffix}{}{\llap{\usekomafont{fromaddress}\usekomavar*{fromfax}}     &%
%                         \usekomafont{fromaddress}\usekomavar{fromfax}\usekomavar{fromfaxsuffix}\tabularnewline}
%                     \ifkomavarempty{fromemail}{}{\llap{\usekomafont{fromaddress}\usekomavar*{fromemail}} &%
%                         \usekomafont{fromaddress}\usekomavar{fromemail}\tabularnewline}
%                     \ifkomavarempty{fromurl}{}{\llap{\usekomafont{fromaddress}\usekomavar*{fromurl}} &%
%                         \usekomafont{fromaddress}\usekomavar{fromurl}\tabularnewline}
%                 \end{tabular}%
                \hspace*{4pt}%
                \parbox{\useplength{intinfocolwidth}}{%
                    \ifkomavarempty{date}{}{\usekomafont{fromaddress}\bfseries\usekomavar{date}}
                \mbox{}}%end of box
	    \end{minipage}%
        }%end of put
    \end{picture}
    \hspace*{\useplength{infocolwidth}}
    %% Definition of the width of the picture environment with \hspace*{} after it as a fill space.
    %% This is easier than the difficult transformation of the pseudo-length infocolwidth into a
    %% corresponding unitlength for \begin{picture}(width,height)!
}%end of firsthead

%% The letter place and date should reside in the firsthead's infoblock and not the reference field!
%% For this, the date-variable must be cleared *after* it is set in the infoblock!
%% ==> otherwise date would appear twice!
\l@addto@macro\@firstheadfootfield{\setkomavar{date}{}}
%% The regular place and date (= minimum version of the reference field) will be ommited now!
%% CAUTION: this changes the *internal* command @firstheadfootfield!
%% Future versions of scrlttr2 might show a different behavior or provide a regular command to turn the date off!
% --------------------------------------------------------------------------------------------


%% definition of the custom IMTEK letter foot ================================================
\RequirePackage{totpages}
\firstfoot{\strut%
    \makebox[\textwidth][l]{%
	\parbox[t]{\useplength{firstfootwidth}}{%
	    \raisebox{-0.3em}{\usekomafont{pagenumber}\thepage\,/\,\ref{TotPages}} \quad \hrulefill \quad \raisebox{-1.95mm}{\usekomavar{imtekicon}}
% 	    \hrulefill \quad \raisebox{-1.95mm}{\usekomavar{imtekicon}}
        }%end of parbox
    }%end of makebox
}%end of firstfoot

%% definition of the custom footer for all other pages but first one
\nextfoot{\hspace*{-\oddsidemargin}\hspace{-1in}%
    \hspace{\useplength{toaddrhpos}}%
    \makebox[\textwidth][l]{%
        \parbox[t]{\useplength{firstfootwidth}}{%
            ~\\[-\dp\strutbox]
            \raisebox{-0.3em}{\usekomafont{pagenumber}\thepage\,/\,\ref{TotPages}} \quad \hrulefill \quad \raisebox{-1.95mm}{\usekomavar{imtekicon}}
        }%end of parbox
    }%end of makebox
}%end of nextfoot

%% ACHTUNG: (lt. Doku) \nexthead bzw. \nextfoot nur bei Seitenstil headings (bzw. scrheadings) in Verwendung!
%% Undokumentiert: die Elemente pagehead und pagefoot gelten *nicht* fuer \firsthead und \firstfoot!
\pagestyle{headings}
% --------------------------------------------------------------------------------------------

\endinput
%%
%% End of file `IMTEKbrief.cls'.
